package Polynomial;
import ShamirSecretSharing.Polynomial;
import org.junit.Before;
import org.junit.Test;

import java.math.BigInteger;
import java.util.Random;

/**
 * Created by Tzlil on 1/27/2016.
 */
public class AddTest {

    Polynomial[] arr1;
    Polynomial[] arr2;
    int tests = 1 << 12;
    int maxDegree = 15;
    int bits = 128;
    Random random;

    @Before
    public void settings(){
        random = new Random();
        arr1 = new Polynomial[tests];
        arr2 = new Polynomial[tests];
        for (int i = 0; i < arr1.length; i++){
            arr1[i] = Utils.generateRandomPolynomial(random.nextInt(maxDegree),bits,random);
            arr2[i] = Utils.generateRandomPolynomial(random.nextInt(maxDegree),bits,random);
        }
    }

    public void oneTest(Polynomial p1, Polynomial p2){
        Polynomial sum = p1.add(p2);
        BigInteger x = new BigInteger(bits,random);
        assert(sum.image(x).equals(p1.image(x).add(p2.image(x))));
    }

    @Test
    public void addTest(){
        for (int i = 0 ; i < arr1.length; i ++){
            oneTest(arr1[i],arr2[i]);
        }
    }
}
